#region Script Settings
#<ScriptSettings xmlns="http://tempuri.org/ScriptSettings.xsd">
#  <ScriptPackager>
#    <process>powershell.exe</process>
#    <arguments />
#    <extractdir>%TEMP%</extractdir>
#    <files />
#    <usedefaulticon>true</usedefaulticon>
#    <showinsystray>false</showinsystray>
#    <altcreds>false</altcreds>
#    <efs>true</efs>
#    <ntfs>true</ntfs>
#    <local>false</local>
#    <abortonfail>true</abortonfail>
#    <product />
#    <version>1.0.0.1</version>
#    <versionstring />
#    <comments />
#    <includeinterpreter>false</includeinterpreter>
#    <forcecomregistration>false</forcecomregistration>
#    <consolemode>false</consolemode>
#    <EnableChangelog>false</EnableChangelog>
#    <AutoBackup>false</AutoBackup>
#    <snapinforce>false</snapinforce>
#    <snapinshowprogress>false</snapinshowprogress>
#    <snapinautoadd>0</snapinautoadd>
#    <snapinpermanentpath />
#  </ScriptPackager>
#</ScriptSettings>
#endregion

#region ScriptForm Designer

#region Constructor

[void][System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms")
[void][System.Reflection.Assembly]::LoadWithPartialName("System.Drawing")

#endregion

#region Post-Constructor Custom Code

#endregion

#region Form Creation
#Warning: It is recommended that changes inside this region be handled using the ScriptForm Designer.
#When working with the ScriptForm designer this region and any changes within may be overwritten.
#~~< frmSQL >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$frmSQL = New-Object System.Windows.Forms.Form
$frmSQL.ClientSize = New-Object System.Drawing.Size(792, 566)
$frmSQL.Text = "SQL scripts"
#~~< lblCustomScript >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$lblCustomScript = New-Object System.Windows.Forms.Label
$lblCustomScript.Location = New-Object System.Drawing.Point(12, 185)
$lblCustomScript.Size = New-Object System.Drawing.Size(100, 20)
$lblCustomScript.TabIndex = 23
$lblCustomScript.Text = "Custom Script:"
#~~< btnSQLRunCustom >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$btnSQLRunCustom = New-Object System.Windows.Forms.Button
$btnSQLRunCustom.Location = New-Object System.Drawing.Point(652, 206)
$btnSQLRunCustom.Size = New-Object System.Drawing.Size(100, 102)
$btnSQLRunCustom.TabIndex = 22
$btnSQLRunCustom.Text = "Run Custom SQL Script"
$btnSQLRunCustom.UseVisualStyleBackColor = $true
#~~< tbSQLCustom >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$tbSQLCustom = New-Object System.Windows.Forms.TextBox
$tbSQLCustom.Location = New-Object System.Drawing.Point(12, 206)
$tbSQLCustom.Multiline = $true
$tbSQLCustom.Size = New-Object System.Drawing.Size(600, 102)
$tbSQLCustom.TabIndex = 21
$tbSQLCustom.Text = ""
#~~< dgSQLOutput >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$dgSQLOutput = New-Object System.Windows.Forms.DataGridView
$dgSQLOutput.ColumnHeadersHeightSizeMode = [System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode]::AutoSize
$dgSQLOutput.Location = New-Object System.Drawing.Point(12, 314)
$dgSQLOutput.Size = New-Object System.Drawing.Size(740, 240)
$dgSQLOutput.TabIndex = 20
$dgSQLOutput.Text = ""
#~~< btnSQLRunScriptExportExcel >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$btnSQLRunScriptExportExcel = New-Object System.Windows.Forms.Button
$btnSQLRunScriptExportExcel.Location = New-Object System.Drawing.Point(640, 91)
$btnSQLRunScriptExportExcel.Size = New-Object System.Drawing.Size(100, 50)
$btnSQLRunScriptExportExcel.TabIndex = 19
$btnSQLRunScriptExportExcel.Text = "Run Script and Export to Excel"
$btnSQLRunScriptExportExcel.UseVisualStyleBackColor = $true
#~~< btnSQLRunScript >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$btnSQLRunScript = New-Object System.Windows.Forms.Button
$btnSQLRunScript.Location = New-Object System.Drawing.Point(640, 35)
$btnSQLRunScript.Size = New-Object System.Drawing.Size(100, 50)
$btnSQLRunScript.TabIndex = 18
$btnSQLRunScript.Text = "Run Script"
$btnSQLRunScript.UseVisualStyleBackColor = $true
#~~< labelSQLCatalogs >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$labelSQLCatalogs = New-Object System.Windows.Forms.Label
$labelSQLCatalogs.Location = New-Object System.Drawing.Point(424, 9)
$labelSQLCatalogs.Size = New-Object System.Drawing.Size(100, 23)
$labelSQLCatalogs.TabIndex = 17
$labelSQLCatalogs.Text = "SQL Databases:"
#~~< labelSQLServers >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$labelSQLServers = New-Object System.Windows.Forms.Label
$labelSQLServers.Location = New-Object System.Drawing.Point(218, 9)
$labelSQLServers.Size = New-Object System.Drawing.Size(100, 23)
$labelSQLServers.TabIndex = 16
$labelSQLServers.Text = "SQL servers:"
#~~< lbSQLCatalogs >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$lbSQLCatalogs = New-Object System.Windows.Forms.ListBox
$lbSQLCatalogs.FormattingEnabled = $true
$lbSQLCatalogs.Location = New-Object System.Drawing.Point(424, 35)
$lbSQLCatalogs.Size = New-Object System.Drawing.Size(200, 147)
$lbSQLCatalogs.TabIndex = 15
#~~< lbSQLServers >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$lbSQLServers = New-Object System.Windows.Forms.ListBox
$lbSQLServers.FormattingEnabled = $true
$lbSQLServers.Location = New-Object System.Drawing.Point(218, 35)
$lbSQLServers.Size = New-Object System.Drawing.Size(200, 147)
$lbSQLServers.TabIndex = 14
#~~< labelSQLScripts >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$labelSQLScripts = New-Object System.Windows.Forms.Label
$labelSQLScripts.Location = New-Object System.Drawing.Point(12, 9)
$labelSQLScripts.Size = New-Object System.Drawing.Size(100, 23)
$labelSQLScripts.TabIndex = 13
$labelSQLScripts.Text = "Scripts:"
#~~< lbSQLScripts >~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
$lbSQLScripts = New-Object System.Windows.Forms.ListBox
$lbSQLScripts.FormattingEnabled = $true
$lbSQLScripts.Location = New-Object System.Drawing.Point(12, 35)
$lbSQLScripts.Size = New-Object System.Drawing.Size(200, 147)
$lbSQLScripts.TabIndex = 12
$frmSQL.Controls.Add($lblCustomScript)
$frmSQL.Controls.Add($btnSQLRunCustom)
$frmSQL.Controls.Add($tbSQLCustom)
$frmSQL.Controls.Add($dgSQLOutput)
$frmSQL.Controls.Add($btnSQLRunScriptExportExcel)
$frmSQL.Controls.Add($btnSQLRunScript)
$frmSQL.Controls.Add($labelSQLCatalogs)
$frmSQL.Controls.Add($labelSQLServers)
$frmSQL.Controls.Add($lbSQLCatalogs)
$frmSQL.Controls.Add($lbSQLServers)
$frmSQL.Controls.Add($labelSQLScripts)
$frmSQL.Controls.Add($lbSQLScripts)

#endregion

#region Custom Code

#endregion

#region Event Loop

function Main{
	[System.Windows.Forms.Application]::EnableVisualStyles()
	[System.Windows.Forms.Application]::Run($frmSQL)
}

#endregion

#endregion

#region functions
function Perform-SQLquery
{
	param([string]$TaskName, [string]$SqlServer, [string]$SqlCatalog)
	#$TaskName = "low_c_drive"
	#$SqlServer = "ALTIRIS";
	#$SqlCatalog = "eXpress";
	if (($TaskName.length -gt 0) -and ($SqlServer.length -gt 0) -and ($SqlCatalog.length -gt 0))
	{
		# Get the T-SQL Query from .SQL file
		if ($TaskName -match "^###CUSTOM###")
		{
			$SqlQuery = $TaskName -replace ("###CUSTOM###", "")
		}
		else
		{
			$SqlQuery = Get-Content("$WorkingDir\SQL\" + $TaskName + ".sql") | where-Object { $_ -notmatch "^#" }
		}										
		$tbSQLCustom.Text = $SqlQuery										
		# Setup SQL Connection
		$SqlConnection = New-Object System.Data.SqlClient.SqlConnection
		$SqlConnection.ConnectionString = "Server = $SqlServer; Database = $SqlCatalog; Integrated Security = True"
														
		# Setup SQL Command
		$SqlCmd = New-Object System.Data.SqlClient.SqlCommand
		$SqlCmd.CommandText = $SqlQuery
		$SqlCmd.Connection = $SqlConnection
														
		# Setup .NET SQLAdapter to execute and fill .NET Dataset
		$SqlAdapter = New-Object System.Data.SqlClient.SqlDataAdapter
		$SqlAdapter.SelectCommand = $SqlCmd
		$DataSet = New-Object System.Data.DataSet
														
		#Execute and Get Row Count
		$nRecs = $SqlAdapter.Fill($DataSet)
														
		Write-Host($nRecs.ToString() + " Records retrieved.") -foregroundcolor "Cyan"
		if ($nRecs -gt 0)
		{
			$DataSet
		}
		else
		{ 
			Write-Host "No records retrieved in Perform-SQLquery"
			$false
		}
	}
	else
	{
		Write-Host "Incorrect parameters for Perform-SQLquery"
		$false
	}
}
function Perform-SQLtoDataTable
{
	param([string]$TaskName, [string]$SqlServer, [string]$SqlCatalog)
	#$TaskName = "low_c_drive"
	#$SqlServer = "ALTIRIS";
	#$SqlCatalog = "eXpress";
	if (($TaskName.length -gt 0) -and ($SqlServer.length -gt 0) -and ($SqlCatalog.length -gt 0))
	{
										
																					
		#Write-Host ($SqlQuery) -foregroundcolor "gray"
																					
		#$DataSet = New-Object System.Data.DataSet
		$DataSet = Perform-SQLquery "$TaskName" "$SqlServer" "$SqlCatalog"
														
		if ($DataSet-ne $false)
		{
																	
			$line = ""
			Write-Host "Nr of cols" $DataSet.Tables[0].Columns.count
			$nrcols = $DataSet.Tables[0].Columns.count
			$cols = New-Object System.Windows.Forms.DataGridViewTextBoxColumn[] $nrcols
			$colnr = 0
			$dgSQLOutput.Columns.Clear()
			$DataSet.Tables[0].Columns | foreach-Object {
				$_.get_ColumnName() | foreach-Object {
					$cols[$colnr] = New-Object System.Windows.Forms.DataGridViewTextBoxColumn
					$cols[$colnr].HeaderText = $_
					$cols[$colnr].readonly = $true
					#$cols[$colnr].Width = 60
					$cols[$colnr].AutoSizeMode = [System.Windows.Forms.DataGridViewAutoSizeColumnMode]::AllCellsExceptHeader
					$colnr = $colnr + 1
				}
			} 
			$dgSQLOutput.Columns.AddRange($cols)
			$line = ""
			$DataSet.Tables[0].Rows | foreach-Object {
				$dgSQLOutput.Rows.Add($_.get_ItemArray())																																							    
				#$_.get_ItemArray() | foreach-Object {
				#Write-Host "$_;" -noNewLine
				#	$line += "$_;"
				#}
				#Add-Content -path $ofile -value $line
				#Write-Host
				#Add-Content -path $file -value " "
				$line = ""
			}
		}	
	}
}	
function Perform-SQLtoExcel
{
	param([string]$TaskName, [string]$SqlServer, [string]$SqlCatalog)
	#$TaskName = "low_c_drive"
	#$SqlServer = "ALTIRIS";
	#$SqlCatalog = "eXpress";
	if (($TaskName.length -gt 0) -and ($SqlServer.length -gt 0) -and ($SqlCatalog.length -gt 0))
	{
										
																					
		#Write-Host ($SqlQuery) -foregroundcolor "gray"
		$date = [System.DateTime]::Now
		$datestr = $date.ToString("yyyy-MM-dd_hhmmss")
																					
		#$DataSet = New-Object System.Data.DataSet
		$DataSet = Perform-SQLquery "$TaskName" "$SqlServer" "$SqlCatalog"
														
		if ($DataSet-ne $false)
		{
			$ofile = "C:`\temp`\$TaskName"
			$ofile += "_$datestr.xls"
			Write-Host $ofile
			#Set-content -path $file -value "$TaskName_$datestr"
			$excel = New-Object -comobject Excel.Application
			$excel.Visible = $false
			$ci = New-Object System.Globalization.CultureInfo("en-GB")
			$excel.workbooks.psbase.gettype().InvokeMember("Add", [Reflection.BindingFlags]::InvokeMethod, $null, $excel.workbooks, $null, $ci) 
			$book = $excel.workbooks.item(1)
			$sheet = $book.Worksheets.Item(1)
						
			Write-Host "Nr of cols" $DataSet.Tables[0].Columns.count
			$nrcols = $DataSet.Tables[0].Columns.count
			$cols = New-Object System.Windows.Forms.DataGridViewTextBoxColumn[] $nrcols
			$colnr = 0
			$dgSQLOutput.Columns.Clear()
			$DataSet.Tables[0].Columns | foreach-Object {
				$_.get_ColumnName() | foreach-Object {
					$cols[$colnr] = New-Object System.Windows.Forms.DataGridViewTextBoxColumn
					$cols[$colnr].HeaderText = $_
					$cols[$colnr].readonly = $true
					$cols[$colnr].Width = 60
										
					$sheet.Cells.Item(1, $colnr + 1).formulalocal = $_
					$colnr = $colnr + 1
				}
			} 
			$dgSQLOutput.Columns.AddRange($cols)
			
			$line = ""
			$rownr = 2
			$DataSet.Tables[0].Rows | foreach-Object {
				$colnr = 0
				$dgSQLOutput.Rows.Add($_.get_ItemArray())																																			    
				$_.get_ItemArray() | foreach-Object {
					$sheet.Cells.Item($rownr, $colnr + 1).formulalocal = $_
					$colnr = $colnr + 1
				}
				$rownr = $rownr + 1
								
			}
						
			$dgSQLOutput.Update()
			Write-Host "Output written in C:\temp\$TaskName$datestr.xls"
			$excel.workbooks.psbase.gettype().InvokeMember("SaveAs", [Reflection.BindingFlags]::InvokeMethod, $null, $book, $ofile, $ci) 
			$excel.visible = $true
			$excel.workbooks.psbase.gettype().InvokeMember("Save", [Reflection.BindingFlags]::InvokeMethod, $null, $book, $null, $ci) 
			#Perform-OpenExcel $ofile
		}
	}	
}	
function Perform-OpenExcel
{
	param([string]$fileToOpen)
	$StartInfo = New-Object System.Diagnostics.ProcessStartInfo
	$StartInfo.CreateNoWindow = $true
	$StartInfo.UseShellExecute = $false
	$StartInfo.FileName = "C:\Program Files\Microsoft Office\Office10\excel.exe"
	$StartInfo.WorkingDirectory = "C:\Temp"
	$StartInfo.Arguments = "$fileToOpen"
	$p = [System.Diagnostics.Process]::Start($StartInfo)
	#$p.WaitForExit()
	#if ($p.ExitCode -eq 0) { $TRUE } else { $FALSE }
										
}
function Get-SQLDatabases
{
	param([string]$SqlServer)
	Write-Host "Get-SQLDatabases $SqlServer"
	if ($SqlServer.length -gt 0)
	{
		#first determine version
		$SqlConnection = New-Object System.Data.SqlClient.SqlConnection
		$SqlConnection.ConnectionString = "Server = $SqlServer; Integrated Security = True"
		$SqlQuery = "SELECT SERVERPROPERTY('productversion')"		
		# Setup SQL Command
		$SqlCmd = New-Object System.Data.SqlClient.SqlCommand
		$SqlCmd.CommandText = $SqlQuery
		$SqlCmd.Connection = $SqlConnection
																										
		# Setup .NET SQLAdapter to execute and fill .NET Dataset
		$SqlAdapter = New-Object System.Data.SqlClient.SqlDataAdapter
		$SqlAdapter.SelectCommand = $SqlCmd 
		$DataSet = New-Object System.Data.DataSet
																										
		#Execute and Get Row Count
		#try {
		$nRecs = $SqlAdapter.Fill($DataSet)
		#}
																					
																										
		Write-Host($nRecs.ToString() + " Records retrieved.") -foregroundcolor "Cyan"
		$SqlConnection.Close();
		if ($nRecs -gt 0)
		{
			$lbSQLCatalogs.Items.Clear();
			#$DataSet.Tables[0].Rows | foreach-Object {
			#$lbSQLCatalogs.Items.Add($_)
			#}
			$sqlversion = $DataSet.Tables[0].Rows[0].get_ItemArray()[0]
		}
		Write-Host $sqlversion
		$mainversionnumber = [int] ( $sqlversion.Substring(0, 1) )
		if ($mainversionnumber -gt 8)
		{
																																
			$SqlConnection = New-Object System.Data.SqlClient.SqlConnection
			$SqlConnection.ConnectionString = "Server = $SqlServer; Integrated Security = True"
			$SqlQuery = "SELECT Name FROM SYS.databases ORDER BY Name ASC"		
			# Setup SQL Command
			$SqlCmd = New-Object System.Data.SqlClient.SqlCommand
			$SqlCmd.CommandText = $SqlQuery
			$SqlCmd.Connection = $SqlConnection
																																					
			# Setup .NET SQLAdapter to execute and fill .NET Dataset
			$SqlAdapter = New-Object System.Data.SqlClient.SqlDataAdapter
			$SqlAdapter.SelectCommand = $SqlCmd 
			$DataSet = New-Object System.Data.DataSet
																																					
			#Execute and Get Row Count
			#try {
			$nRecs = $SqlAdapter.Fill($DataSet)
			#}
																																
																																					
			Write-Host($nRecs.ToString() + " Records retrieved.") -foregroundcolor "Cyan"
			$SqlConnection.Close();
			if ($nRecs -gt 0)
			{
				$lbSQLCatalogs.Items.Clear();
				$DataSet.Tables[0].Rows | foreach-Object {
					$lbSQLCatalogs.Items.Add($_.get_ItemArray()[0])
				}
			}
		}
		else
		{
			$SqlConnection = New-Object System.Data.SqlClient.SqlConnection
			$SqlConnection.ConnectionString = "Server = $SqlServer; Integrated Security = True"
			$SqlQuery = "sp_databases"		
			# Setup SQL Command
			$SqlCmd = New-Object System.Data.SqlClient.SqlCommand
			$SqlCmd.CommandText = $SqlQuery
			$SqlCmd.Connection = $SqlConnection
																																										
			# Setup .NET SQLAdapter to execute and fill .NET Dataset
			$SqlAdapter = New-Object System.Data.SqlClient.SqlDataAdapter
			$SqlAdapter.SelectCommand = $SqlCmd 
			$DataSet = New-Object System.Data.DataSet
																																										
			#Execute and Get Row Count
			$nRecs = $SqlAdapter.Fill($DataSet)
																																										
			Write-Host($nRecs.ToString() + " Records retrieved.") -foregroundcolor "Cyan"
			$SqlConnection.Close();
			if ($nRecs -gt 0)
			{
				$lbSQLCatalogs.Items.Clear();
				$DataSet.Tables[0].Rows | foreach-Object {
					$lbSQLCatalogs.Items.Add($_.get_ItemArray()[0])
				}
			}	
		}
	}
	else
	{
		Write-Host "No SqlServer defined"
	}
														
}
function fnLbSQLServers-SelectedValueChanged($object)
{
	Write-Host "fnLbSQLServers-SelectedValueChanged: " $lbSQLServers.get_SelectedItem()
	if ($lbSQLServers.get_SelectedItem().length -gt 0) { Get-SQLDatabases($lbSQLServers.get_SelectedItem()) }
}
function fnBtnSQLRunScript-Clicked($object)
{
	if (($lbSQLScripts.get_SelectedItem().length -gt 0) -and ($lbSQLServers.get_SelectedItem().length -gt 0) -and ($lbSQLCatalogs.get_SelectedItem().length -gt 0))
	{
		$script = $lbSQLScripts.get_SelectedItem()
		$sqlserver = $lbSQLServers.get_SelectedItem()
		$sqlcatalog = $lbSQLCatalogs.get_SelectedItem()
		Perform-SQLtoDataTable "$script" "$sqlserver" "$sqlcatalog"
	}
	else
	{
		Write-Host "No Database or SQL catalog selected - autoselecting"
		#dummy proof implementation
		if (($lbSQLScripts.get_SelectedItem().length -gt 0))
		{
			$script = $lbSQLScripts.get_SelectedItem()
			$shortname = ($script.split("_"))[0]
            $xmlfileshortnames = "$WorkingDir\\shortnames.xml"
            $xmldatashortnames = New-Object "System.Xml.XmlDocument"
            $xmldatashortnames.Load($xmlfileshortnames)
            $shortelement = $xmldatashortnames.SelectSingleNode("shortnames/shortname[@id='$shortname']")
            if ($shortelement -ne $null){
                $lbSQLServers.set_SelectedItem($shortelement.server)
				if ($lbSQLServers.get_SelectedItem().length -gt 0) { Get-SQLDatabases($lbSQLServers.get_SelectedItem()) }
				$lbSQLCatalogs.set_SelectedItem($shortelement.database)
            }
			$sqlserver = $lbSQLServers.get_SelectedItem()
			$sqlcatalog = $lbSQLCatalogs.get_SelectedItem()
            if(( $lbSQLServers.get_SelectedItem().length -gt 0 ) -and ($lbSQLCatalogs.get_SelectedItem().length -gt 0 )){
			Perform-SQLtoDataTable "$script" "$sqlserver" "$sqlcatalog"
            }
		}
	}
						
}

function fnBtnSQLRunCustom-Clicked($object)
{
	if (($tbSQLCustom.text.length -gt 0) -and ($lbSQLServers.get_SelectedItem().length -gt 0) -and ($lbSQLCatalogs.get_SelectedItem().length -gt 0))
	{
		$qry = $tbSQLCustom.text
		$script = "###CUSTOM###$qry"
		$sqlserver = $lbSQLServers.get_SelectedItem()
		$sqlcatalog = $lbSQLCatalogs.get_SelectedItem()
		Perform-SQLtoDataTable "$script" "$sqlserver" "$sqlcatalog"
	}
}
function fnBtnSQLRunScriptExportExcel-Clicked($object)
{
	if (($lbSQLScripts.get_SelectedItem().length -gt 0) -and ($lbSQLServers.get_SelectedItem().length -gt 0) -and ($lbSQLCatalogs.get_SelectedItem().length -gt 0))
	{
		$script = $lbSQLScripts.get_SelectedItem()
		$sqlserver = $lbSQLServers.get_SelectedItem()
		$sqlcatalog = $lbSQLCatalogs.get_SelectedItem()
		Perform-SQLtoExcel "$script" "$sqlserver" "$sqlcatalog"
	}
	else
	{
		Write-Host "No Database or SQL catalog selected - autoselecting"
		#dummy proof implementation
		if (($lbSQLScripts.get_SelectedItem().length -gt 0))
		{
			$script = $lbSQLScripts.get_SelectedItem()
            $shortname = ($script.split("_"))[0]
            $xmlfileshortnames = "$WorkingDir\\shortnames.xml"
            $xmldatashortnames = New-Object "System.Xml.XmlDocument"
            $xmldatashortnames.Load($xmlfileshortnames)
            $shortelement = $xmldatashortnames.SelectSingleNode("shortnames/shortname[@id='$shortname']")
            if ($shortelement -ne $null){
                #Write-Host ($shortelement.server)
                $lbSQLServers.set_SelectedItem($shortelement.server)
				if ($lbSQLServers.get_SelectedItem().length -gt 0) { Get-SQLDatabases($lbSQLServers.get_SelectedItem()) }
				$lbSQLCatalogs.set_SelectedItem($shortelement.database)
            }
			$sqlserver = $lbSQLServers.get_SelectedItem()
			$sqlcatalog = $lbSQLCatalogs.get_SelectedItem()
            if(( $lbSQLServers.get_SelectedItem().length -gt 0 ) -and ($lbSQLCatalogs.get_SelectedItem().length -gt 0 )){
			 Perform-SQLtoExcel "$script" "$sqlserver" "$sqlcatalog"
            }
		}
	}
}
#endregion
#region addevents
function BuildTables
{
Write-Host "BuildTables"
$lbSQLServers.Items.Clear();
#$sqlservers = "SQLSERVER", "ALTIRIS"
#$sqlservers | foreach-object -process { $lbSQLServers.Items.Add($_) >$null}

$xmlfileservers = "$WorkingDir\\servers.xml"
$xmldataservers = New-Object "System.Xml.XmlDocument"
$xmldataservers.Load($xmlfileservers)
$xmldataservers.selectnodes("/servers/server") | foreach-object -process { $lbSQLServers.Items.Add($_.InnerText) >$null  }
$lbSQLScripts.Items.Clear();    
Get-ChildItem -path $WorkingDir\SQL\*.sql | foreach-object -process {
	if (($_.get_Extension().length -gt 0) -and ($_.get_Extension().length -lt $_.get_Name().length))
	{
		$lbSQLScripts.items.add($_.get_Name().Remove($_.get_Name().Length - $_.get_Extension().Length)) >$null
	}
	else
	{  
		$lbSQLScripts.items.add($_.get_Name()) >$null
	}  
}
}
$lbSQLServers.add_SelectedValueChanged({ fnLbSQLServers-SelectedValueChanged($lbSQLServers) })
$btnSQLRunScriptExportExcel.add_Click({ fnBtnSQLRunScriptExportExcel-Clicked($btnSQLRunScriptExportExcel) })
$btnSQLRunScript.add_Click({ fnBtnSQLRunScript-Clicked($btnSQLRunScript) })
$btnSQLRunCustom.add_Click({ fnBtnSQLRunCustom-Clicked($btnSQLRunCustom) })
$b = $myInvocation
Write-Host $b.InvocationName
Write-Host $b.line
$dummy = ($b.line.Replace(". ", "").Replace("&", "").Replace(".'", "'").Replace("\frmSQLscripts.ps1", "").Replace("\frmSQLscripts.ps1", "").Replace("'", ""))
$dummy = $dummy.trim()
Write-Host "Workingdir:$dummy"
$global:WorkingDir = $dummy
if ((test-path $WorkingDir\SQL) -eq $false){ $global:WorkingDir="C:\\Documents and Settings\\XPMUser\\Desktop\\PowerShell\\SQL" }
BuildTables
#endregion

#region Event Handlers

Main #This call must remain below all other event functions

#endregion
		
		